git-rebase.shon commit t6036: criss-cross + rename/rename(1to2)/add-dest + simple modify (b630b81)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_SPEC=
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37LF='
  38'
  39OK_TO_SKIP_PRE_REBASE=
  40RESOLVEMSG="
  41When you have resolved this problem run \"git rebase --continue\".
  42If you would prefer to skip this patch, instead run \"git rebase --skip\".
  43To restore the original branch and stop rebasing run \"git rebase --abort\".
  44"
  45unset newbase
  46strategy=recursive
  47strategy_opts=
  48do_merge=
  49dotest="$GIT_DIR"/rebase-merge
  50prec=4
  51verbose=
  52diffstat=
  53test "$(git config --bool rebase.stat)" = true && diffstat=t
  54git_am_opt=
  55rebase_root=
  56force_rebase=
  57allow_rerere_autoupdate=
  58
  59continue_merge () {
  60        test -n "$prev_head" || die "prev_head must be defined"
  61        test -d "$dotest" || die "$dotest directory does not exist"
  62
  63        unmerged=$(git ls-files -u)
  64        if test -n "$unmerged"
  65        then
  66                echo "You still have unmerged paths in your index"
  67                echo "did you forget to use git add?"
  68                die "$RESOLVEMSG"
  69        fi
  70
  71        cmt=`cat "$dotest/current"`
  72        if ! git diff-index --quiet --ignore-submodules HEAD --
  73        then
  74                if ! git commit --no-verify -C "$cmt"
  75                then
  76                        echo "Commit failed, please do not call \"git commit\""
  77                        echo "directly, but instead do one of the following: "
  78                        die "$RESOLVEMSG"
  79                fi
  80                if test -z "$GIT_QUIET"
  81                then
  82                        printf "Committed: %0${prec}d " $msgnum
  83                fi
  84                echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
  85        else
  86                if test -z "$GIT_QUIET"
  87                then
  88                        printf "Already applied: %0${prec}d " $msgnum
  89                fi
  90        fi
  91        test -z "$GIT_QUIET" &&
  92        GIT_PAGER='' git log --format=%s -1 "$cmt"
  93
  94        prev_head=`git rev-parse HEAD^0`
  95        # save the resulting commit so we can read-tree on it later
  96        echo "$prev_head" > "$dotest/prev_head"
  97
  98        # onto the next patch:
  99        msgnum=$(($msgnum + 1))
 100        echo "$msgnum" >"$dotest/msgnum"
 101}
 102
 103call_merge () {
 104        cmt="$(cat "$dotest/cmt.$1")"
 105        echo "$cmt" > "$dotest/current"
 106        hd=$(git rev-parse --verify HEAD)
 107        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
 108        msgnum=$(cat "$dotest/msgnum")
 109        end=$(cat "$dotest/end")
 110        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
 111        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
 112        export GITHEAD_$cmt GITHEAD_$hd
 113        if test -n "$GIT_QUIET"
 114        then
 115                GIT_MERGE_VERBOSITY=1 && export GIT_MERGE_VERBOSITY
 116        fi
 117        eval 'git-merge-$strategy' $strategy_opts '"$cmt^" -- "$hd" "$cmt"'
 118        rv=$?
 119        case "$rv" in
 120        0)
 121                unset GITHEAD_$cmt GITHEAD_$hd
 122                return
 123                ;;
 124        1)
 125                git rerere $allow_rerere_autoupdate
 126                die "$RESOLVEMSG"
 127                ;;
 128        2)
 129                echo "Strategy: $rv $strategy failed, try another" 1>&2
 130                die "$RESOLVEMSG"
 131                ;;
 132        *)
 133                die "Unknown exit code ($rv) from command:" \
 134                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 135                ;;
 136        esac
 137}
 138
 139move_to_original_branch () {
 140        test -z "$head_name" &&
 141                head_name="$(cat "$dotest"/head-name)" &&
 142                onto="$(cat "$dotest"/onto)" &&
 143                orig_head="$(cat "$dotest"/orig-head)"
 144        case "$head_name" in
 145        refs/*)
 146                message="rebase finished: $head_name onto $onto"
 147                git update-ref -m "$message" \
 148                        $head_name $(git rev-parse HEAD) $orig_head &&
 149                git symbolic-ref HEAD $head_name ||
 150                die "Could not move back to $head_name"
 151                ;;
 152        esac
 153}
 154
 155finish_rb_merge () {
 156        move_to_original_branch
 157        git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 158        if test -x "$GIT_DIR"/hooks/post-rewrite &&
 159                test -s "$dotest"/rewritten; then
 160                "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 161        fi
 162        rm -r "$dotest"
 163        say All done.
 164}
 165
 166is_interactive () {
 167        while test $# != 0
 168        do
 169                case "$1" in
 170                        -i|--interactive)
 171                                interactive_rebase=explicit
 172                                break
 173                        ;;
 174                        -p|--preserve-merges)
 175                                interactive_rebase=implied
 176                        ;;
 177                esac
 178                shift
 179        done
 180
 181        if [ "$interactive_rebase" = implied ]; then
 182                GIT_EDITOR=:
 183                export GIT_EDITOR
 184        fi
 185
 186        test -n "$interactive_rebase" || test -f "$dotest"/interactive
 187}
 188
 189run_pre_rebase_hook () {
 190        if test -z "$OK_TO_SKIP_PRE_REBASE" &&
 191           test -x "$GIT_DIR/hooks/pre-rebase"
 192        then
 193                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
 194                die "The pre-rebase hook refused to rebase."
 195        fi
 196}
 197
 198test -f "$GIT_DIR"/rebase-apply/applying &&
 199        die 'It looks like git-am is in progress. Cannot rebase.'
 200
 201is_interactive "$@" && exec git-rebase--interactive "$@"
 202
 203while test $# != 0
 204do
 205        case "$1" in
 206        --no-verify)
 207                OK_TO_SKIP_PRE_REBASE=yes
 208                ;;
 209        --verify)
 210                OK_TO_SKIP_PRE_REBASE=
 211                ;;
 212        --continue)
 213                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 214                        die "No rebase in progress?"
 215
 216                git update-index --ignore-submodules --refresh &&
 217                git diff-files --quiet --ignore-submodules || {
 218                        echo "You must edit all merge conflicts and then"
 219                        echo "mark them as resolved using git add"
 220                        exit 1
 221                }
 222                if test -d "$dotest"
 223                then
 224                        prev_head=$(cat "$dotest/prev_head")
 225                        end=$(cat "$dotest/end")
 226                        msgnum=$(cat "$dotest/msgnum")
 227                        onto=$(cat "$dotest/onto")
 228                        GIT_QUIET=$(cat "$dotest/quiet")
 229                        continue_merge
 230                        while test "$msgnum" -le "$end"
 231                        do
 232                                call_merge "$msgnum"
 233                                continue_merge
 234                        done
 235                        finish_rb_merge
 236                        exit
 237                fi
 238                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 239                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 240                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 241                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 242                git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
 243                move_to_original_branch
 244                exit
 245                ;;
 246        --skip)
 247                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 248                        die "No rebase in progress?"
 249
 250                git reset --hard HEAD || exit $?
 251                if test -d "$dotest"
 252                then
 253                        git rerere clear
 254                        prev_head=$(cat "$dotest/prev_head")
 255                        end=$(cat "$dotest/end")
 256                        msgnum=$(cat "$dotest/msgnum")
 257                        msgnum=$(($msgnum + 1))
 258                        onto=$(cat "$dotest/onto")
 259                        GIT_QUIET=$(cat "$dotest/quiet")
 260                        while test "$msgnum" -le "$end"
 261                        do
 262                                call_merge "$msgnum"
 263                                continue_merge
 264                        done
 265                        finish_rb_merge
 266                        exit
 267                fi
 268                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 269                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 270                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 271                GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
 272                git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
 273                move_to_original_branch
 274                exit
 275                ;;
 276        --abort)
 277                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 278                        die "No rebase in progress?"
 279
 280                git rerere clear
 281
 282                test -d "$dotest" || dotest="$GIT_DIR"/rebase-apply
 283
 284                head_name="$(cat "$dotest"/head-name)" &&
 285                case "$head_name" in
 286                refs/*)
 287                        git symbolic-ref HEAD $head_name ||
 288                        die "Could not move back to $head_name"
 289                        ;;
 290                esac
 291                git reset --hard $(cat "$dotest/orig-head")
 292                rm -r "$dotest"
 293                exit
 294                ;;
 295        --onto)
 296                test 2 -le "$#" || usage
 297                newbase="$2"
 298                shift
 299                ;;
 300        -M|-m|--m|--me|--mer|--merg|--merge)
 301                do_merge=t
 302                ;;
 303        -X*|--strategy-option*)
 304                case "$#,$1" in
 305                1,-X|1,--strategy-option)
 306                        usage ;;
 307                *,-X|*,--strategy-option)
 308                        newopt="$2"
 309                        shift ;;
 310                *,--strategy-option=*)
 311                        newopt="$(expr " $1" : ' --strategy-option=\(.*\)')" ;;
 312                *,-X*)
 313                        newopt="$(expr " $1" : ' -X\(.*\)')" ;;
 314                1,*)
 315                        usage ;;
 316                esac
 317                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$newopt")"
 318                do_merge=t
 319                ;;
 320        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 321                --strateg=*|--strategy=*|\
 322        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 323                case "$#,$1" in
 324                *,*=*)
 325                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 326                1,*)
 327                        usage ;;
 328                *)
 329                        strategy="$2"
 330                        shift ;;
 331                esac
 332                do_merge=t
 333                ;;
 334        -n|--no-stat)
 335                diffstat=
 336                ;;
 337        --stat)
 338                diffstat=t
 339                ;;
 340        -v|--verbose)
 341                verbose=t
 342                diffstat=t
 343                GIT_QUIET=
 344                ;;
 345        -q|--quiet)
 346                GIT_QUIET=t
 347                git_am_opt="$git_am_opt -q"
 348                verbose=
 349                diffstat=
 350                ;;
 351        --whitespace=*)
 352                git_am_opt="$git_am_opt $1"
 353                case "$1" in
 354                --whitespace=fix|--whitespace=strip)
 355                        force_rebase=t
 356                        ;;
 357                esac
 358                ;;
 359        --ignore-whitespace)
 360                git_am_opt="$git_am_opt $1"
 361                ;;
 362        --committer-date-is-author-date|--ignore-date)
 363                git_am_opt="$git_am_opt $1"
 364                force_rebase=t
 365                ;;
 366        -C*)
 367                git_am_opt="$git_am_opt $1"
 368                ;;
 369        --root)
 370                rebase_root=t
 371                ;;
 372        -f|--f|--fo|--for|--forc|--force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
 373                force_rebase=t
 374                ;;
 375        --rerere-autoupdate|--no-rerere-autoupdate)
 376                allow_rerere_autoupdate="$1"
 377                ;;
 378        -*)
 379                usage
 380                ;;
 381        *)
 382                break
 383                ;;
 384        esac
 385        shift
 386done
 387test $# -gt 2 && usage
 388
 389if test $# -eq 0 && test -z "$rebase_root"
 390then
 391        test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
 392        test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
 393                die 'A rebase is in progress, try --continue, --skip or --abort.'
 394fi
 395
 396# Make sure we do not have $GIT_DIR/rebase-apply
 397if test -z "$do_merge"
 398then
 399        if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
 400        then
 401                rmdir "$GIT_DIR"/rebase-apply
 402        else
 403                echo >&2 '
 404It seems that I cannot create a rebase-apply directory, and
 405I wonder if you are in the middle of patch application or another
 406rebase.  If that is not the case, please
 407        rm -fr '"$GIT_DIR"'/rebase-apply
 408and run me again.  I am stopping in case you still have something
 409valuable there.'
 410                exit 1
 411        fi
 412else
 413        if test -d "$dotest"
 414        then
 415                die "previous rebase directory $dotest still exists." \
 416                        'Try git rebase (--continue | --abort | --skip)'
 417        fi
 418fi
 419
 420require_clean_work_tree "rebase" "Please commit or stash them."
 421
 422if test -z "$rebase_root"
 423then
 424        # The upstream head must be given.  Make sure it is valid.
 425        upstream_name="$1"
 426        shift
 427        upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 428        die "invalid upstream $upstream_name"
 429        unset root_flag
 430        upstream_arg="$upstream_name"
 431else
 432        test -z "$newbase" && die "--root must be used with --onto"
 433        unset upstream_name
 434        unset upstream
 435        root_flag="--root"
 436        upstream_arg="$root_flag"
 437fi
 438
 439# Make sure the branch to rebase onto is valid.
 440onto_name=${newbase-"$upstream_name"}
 441case "$onto_name" in
 442*...*)
 443        if      left=${onto_name%...*} right=${onto_name#*...} &&
 444                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 445        then
 446                case "$onto" in
 447                ?*"$LF"?*)
 448                        die "$onto_name: there are more than one merge bases"
 449                        ;;
 450                '')
 451                        die "$onto_name: there is no merge base"
 452                        ;;
 453                esac
 454        else
 455                die "$onto_name: there is no merge base"
 456        fi
 457        ;;
 458*)
 459        onto=$(git rev-parse --verify "${onto_name}^0") || exit
 460        ;;
 461esac
 462
 463# If a hook exists, give it a chance to interrupt
 464run_pre_rebase_hook "$upstream_arg" "$@"
 465
 466# If the branch to rebase is given, that is the branch we will rebase
 467# $branch_name -- branch being rebased, or HEAD (already detached)
 468# $orig_head -- commit object name of tip of the branch before rebasing
 469# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 470switch_to=
 471case "$#" in
 4721)
 473        # Is it "rebase other $branchname" or "rebase other $commit"?
 474        branch_name="$1"
 475        switch_to="$1"
 476
 477        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 478           branch=$(git rev-parse -q --verify "refs/heads/$1")
 479        then
 480                head_name="refs/heads/$1"
 481        elif branch=$(git rev-parse -q --verify "$1")
 482        then
 483                head_name="detached HEAD"
 484        else
 485                echo >&2 "fatal: no such branch: $1"
 486                usage
 487        fi
 488        ;;
 489*)
 490        # Do not need to switch branches, we are already on it.
 491        if branch_name=`git symbolic-ref -q HEAD`
 492        then
 493                head_name=$branch_name
 494                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 495        else
 496                head_name="detached HEAD"
 497                branch_name=HEAD ;# detached
 498        fi
 499        branch=$(git rev-parse --verify "${branch_name}^0") || exit
 500        ;;
 501esac
 502orig_head=$branch
 503
 504# Now we are rebasing commits $upstream..$branch (or with --root,
 505# everything leading up to $branch) on top of $onto
 506
 507# Check if we are already based on $onto with linear history,
 508# but this should be done only when upstream and onto are the same.
 509mb=$(git merge-base "$onto" "$branch")
 510if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 511        # linear history?
 512        ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
 513then
 514        if test -z "$force_rebase"
 515        then
 516                # Lazily switch to the target branch if needed...
 517                test -z "$switch_to" || git checkout "$switch_to" --
 518                say "Current branch $branch_name is up to date."
 519                exit 0
 520        else
 521                say "Current branch $branch_name is up to date, rebase forced."
 522        fi
 523fi
 524
 525# Detach HEAD and reset the tree
 526say "First, rewinding head to replay your work on top of it..."
 527git checkout -q "$onto^0" || die "could not detach HEAD"
 528git update-ref ORIG_HEAD $branch
 529
 530if test -n "$diffstat"
 531then
 532        if test -n "$verbose"
 533        then
 534                echo "Changes from $mb to $onto:"
 535        fi
 536        # We want color (if set), but no pager
 537        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 538fi
 539
 540# If the $onto is a proper descendant of the tip of the branch, then
 541# we just fast-forwarded.
 542if test "$mb" = "$branch"
 543then
 544        say "Fast-forwarded $branch_name to $onto_name."
 545        move_to_original_branch
 546        exit 0
 547fi
 548
 549if test -n "$rebase_root"
 550then
 551        revisions="$onto..$orig_head"
 552else
 553        revisions="$upstream..$orig_head"
 554fi
 555
 556if test -z "$do_merge"
 557then
 558        git format-patch -k --stdout --full-index --ignore-if-in-upstream \
 559                --src-prefix=a/ --dst-prefix=b/ \
 560                --no-renames $root_flag "$revisions" |
 561        git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
 562        move_to_original_branch
 563        ret=$?
 564        test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
 565                echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
 566                echo $onto > "$GIT_DIR"/rebase-apply/onto &&
 567                echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
 568                echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
 569        exit $ret
 570fi
 571
 572# start doing a rebase with git-merge
 573# this is rename-aware if the recursive (default) strategy is used
 574
 575mkdir -p "$dotest"
 576echo "$onto" > "$dotest/onto"
 577echo "$onto_name" > "$dotest/onto_name"
 578prev_head=$orig_head
 579echo "$prev_head" > "$dotest/prev_head"
 580echo "$orig_head" > "$dotest/orig-head"
 581echo "$head_name" > "$dotest/head-name"
 582echo "$GIT_QUIET" > "$dotest/quiet"
 583
 584msgnum=0
 585for cmt in `git rev-list --reverse --no-merges "$revisions"`
 586do
 587        msgnum=$(($msgnum + 1))
 588        echo "$cmt" > "$dotest/cmt.$msgnum"
 589done
 590
 591echo 1 >"$dotest/msgnum"
 592echo $msgnum >"$dotest/end"
 593
 594end=$msgnum
 595msgnum=1
 596
 597while test "$msgnum" -le "$end"
 598do
 599        call_merge "$msgnum"
 600        continue_merge
 601done
 602
 603finish_rb_merge